from collections import deque

from log import log


class Agenda(deque):
    def __init__(self, known_edges, options, edges=None):
        # hrany by šly ukládat i do defaultdict
        # klíčem by bylo str() a hodnotou počet výskytů anebo
        # seznam rodičů – nerozlišuju způsob vytvoření!
        super().__init__()
        self.known_edges = known_edges
        self.print_edges = options['print_edges']
        if edges is not None:
            for edge in edges:
                self.append(edge)

    def append(self, edge):
        if edge not in self.known_edges:
            super().append(edge)
            self.known_edges.add(edge)
            if self.print_edges:
                log.info(edge.how_created, edge)
        elif self.print_edges and not edge.how_created.startswith('predict'):
            log.warning(edge.how_created, edge)

    def popleft(self):
        edge = super().popleft()
        if self.print_edges:
            log.info('             %s', edge)
        return edge
